/*
 * CODE-IT 2011-2012
 * EX. 1
 * 
 * Author: 	Valentin Kirilov
 * E-mail: 	val.kirilov@gmail.com
 * 			gep_150@abv.bg
 * WEB site: www.gep150.tk
 * 
 * ELSYS 2011-2012
 * DATE: 07.11.2011
 * All rights reserved
 * 
 */
 
 #include <iostream>
 #include <fstream>
 #include <cstdlib>
 #include <ctime>
 #include <list>
 
 using namespace std;
 
 /* Define main variables and constants
  ------------------------------------------------------------------- */
 
 string inFileName = "flood-it.in";
 string outFileName = "flood-it.out";
 int const _MAX_ARRAY_SIZE_ = 350;
 int const _MAX_COLORS_ = 500;
 

 int arrayVisitedNeighbour[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_];
 int arrayMostColored[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_];
 int arrayBestNeighbour[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_];
 int arrayBestNeighbourColor[_MAX_COLORS_+1];

 int movesCounter = 0;
 int mostColoredPosX = 0;
 int mostColoredPosY = 0;
 int arrayMoves[(_MAX_ARRAY_SIZE_ * _MAX_ARRAY_SIZE_) + 1];
 
 // Revision 4 variables
 int arraySize; 														// Size of the array::input
 int allColors;															// All colors::input
 int array[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_];							// Main array::input and working
 int arrayVisited[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_]; 					// Main visited places
 int arrayBorders[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_];					// Current borders
 int arrayBestColor[_MAX_COLORS_+1]; 									// Best color in the range [borders]
 int colorsReady;
 int startPositionY, startPositionX;

/* Declare main functions
 -------------------------------------------------------------------- */  

 // Structure of a point
 struct pointCoords {
	int x;
	int y; 
 };
 
 list<pointCoords> listBorders;
 
 // Read input information
 void readInputInformation() {
	
	ifstream fileIn("flood-it.in");
	string readValue;
	
	while(fileIn.good()) {
		//getline(fileIn, readValue);
		
		// Read array size
		getline(fileIn, readValue, ' ');
		arraySize = atoi(readValue.c_str());
		//cout << "Array size: " << arraySize << endl;
		
		// Read colors
		getline(fileIn, readValue);
		allColors = atoi(readValue.c_str());
		//cout << "Colors: " << allColors << endl;
		
		// Read array and colors
		for(int counterRows=0; counterRows<arraySize; counterRows++) {
			for(int counterCols=0; counterCols<arraySize; counterCols++) {
				if(counterCols == (arraySize-1)) { getline(fileIn, readValue, '\n'); }
				else if(counterCols < (arraySize-1)) { getline(fileIn, readValue, ' '); }
				
				array[counterRows][counterCols] = atoi(readValue.c_str());
			}
		}
		getline(fileIn, readValue);
	}
	
	fileIn.close();
 }
 
 // Write output information
 void writeOutputInformation() {
	
	ofstream fileOut("flood-it.out");
	
	// Write moves
	fileOut << movesCounter << endl;
	
	// Write startring pos
	fileOut << startPositionY << " " << startPositionX << endl;
	
	// Write colors in moves
	for(int counter=1; counter <= movesCounter; counter++) {
		fileOut << arrayMoves[counter] << endl;
	}
	
	fileOut.close();
 }
 
 // Show array
 void showArray(int (&array)[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_]) {
	for(int counterRows=0; counterRows<arraySize; counterRows++) {
		for(int counterCols=0; counterCols<arraySize; counterCols++) {
			cout << array[counterRows][counterCols] << " ";
		}
		cout << endl;
	}
	cout << endl;
 }
 
 // Make everything to 0
 void createArray(int (&array)[_MAX_ARRAY_SIZE_][_MAX_ARRAY_SIZE_]) {
	for(int counterRows=0; counterRows<arraySize; counterRows++) {
		for(int counterCols=0; counterCols<arraySize; counterCols++) {
			array[counterRows][counterCols] = 0;
		}
	}
 }
 
 
 // Make everything to 0
 void resetSmallArray(int (&array)[_MAX_COLORS_+1]) {
	for(int counterRows=0; counterRows<arraySize; counterRows++) {
		array[counterRows] = 0;
	}
 }
 
 // find new borders
 void findFisrtColor(int currentRow, int currentCol, int startRow, int startCol)
 {
	// Return if we are outside
	if((currentRow < 0) || (currentRow >= arraySize) || (currentCol < 0) || (currentCol >= arraySize)) 
	{
		return;
	}
	
	// Return if we were here
	if(arrayVisited[currentRow][currentCol] == 1) 
	{
		return;
	}
	
	// If the color is not the same
	if(array[currentRow][currentCol] != array[startRow][startCol]) 
	{
		arrayVisited[currentRow][currentCol] = 1;
		arrayBestColor[array[currentRow][currentCol]]++;
		return;
	}
	
	// Set as visited and call function again
	arrayVisited[currentRow][currentCol] = 1;
	
	findFisrtColor(currentRow-1, currentCol, startRow, startCol);
	findFisrtColor(currentRow, currentCol+1, startRow, startCol);
	findFisrtColor(currentRow+1, currentCol, startRow, startCol);
	findFisrtColor(currentRow, currentCol-1, startRow, startCol);
 }
 
 // Set new color
 void setNewColor(int currentRow, int currentCol, int newColor, int startRow, int startCol)
 {
	// Return if we are outside
	if((currentRow < 0) || (currentRow >= arraySize) || (currentCol < 0) || (currentCol >= arraySize)) 
	{
		return;
	}
	
	// Return if we were here
	if(arrayVisited[currentRow][currentCol] == 1) 
	{
		return;
	}
	
	// If the color is not the same
	if(array[currentRow][currentCol] != array[startRow][startCol]) 
	{
		arrayVisited[currentRow][currentCol] = 1;
		arrayBestColor[array[currentRow][currentCol]]++;
		//cout << "    color " << array[currentRow][currentCol] << " increment to " <<  arrayBestColor[array[currentRow][currentCol]] << endl;
		return;
	}
	
	// Set as visited and call function again
	arrayVisited[currentRow][currentCol] = 1;
	
	setNewColor(currentRow-1, currentCol, newColor, startRow, startCol);
	setNewColor(currentRow, currentCol+1, newColor, startRow, startCol);
	setNewColor(currentRow+1, currentCol, newColor, startRow, startCol);
	setNewColor(currentRow, currentCol-1, newColor, startRow, startCol);
	
	array[currentRow][currentCol] = newColor;
	//colorsReady++;
	//cout << "Ready " << currentRow << ":" << currentCol << endl;
 }
 
 
// Start program
void startProgram()
{
	
	colorsReady = 1;
	int currentNewColor = 1;
	int currentLastColor;
	int currentMaxColor = 1;
	movesCounter = 0;
	
	/*
	// Set up first borders
	// .. create starting position
	createArray(arrayBorders);
	pointCoords startingPosition = { startPositionX, startPositionY };
	listBorders.push_back(startingPosition);
	// .. calculate first borders
	findNewBorders(startPositionY, startringPosX, array[startringPosY][startringPosX], startringPosY, startringPosX);
	*/
	
	// Prepare to start the program
	createArray(arrayVisited);
	resetSmallArray(arrayBestColor);
	findFisrtColor(startPositionY, startPositionX, startPositionY, startPositionX);
	
	while(currentMaxColor > 0)
	//while(currentMaxColor != 0)
	{
		
		for(int i=1; i<=allColors; i++)
		{
			//cout << "["<<i<<"]=" << arrayBestColor[i] << "; ";
		}
		
		currentMaxColor = 0;
		// Choose which color to set
		for(int currentColorIndex=1; currentColorIndex<=allColors; currentColorIndex++)
		{
			if((arrayBestColor[currentColorIndex] > currentMaxColor) && (currentColorIndex != currentLastColor)) 
			{
				currentMaxColor = arrayBestColor[currentColorIndex];
				currentNewColor = currentColorIndex;
			}
		}
		//cout << "New color=" << currentNewColor << endl;
		
		// Clear visited places and change color
		createArray(arrayVisited);
		resetSmallArray(arrayBestColor);		
		
		setNewColor(startPositionY, startPositionX, currentNewColor, startPositionY, startPositionX);
		//showArray(array);
		
		currentLastColor = array[startPositionY][startPositionX];
		
		//colorsReady = 1;
		
		// Set moves
		if(currentMaxColor != 0)
		{
			movesCounter++;
			arrayMoves[movesCounter] = currentNewColor;
		}
	}
	
}
 
  
 int main()
 {
	// Official
	
	// Read input information
	readInputInformation();

	// Set up start positions
	startPositionY = arraySize/2;
	startPositionX = arraySize/2;

	// Start program algorythm
	startProgram();

	// Write outpur/results informatiob
	writeOutputInformation();	
	
	// Testing
	/*
	// Time working
	clock_t startTime = clock();
		
	// Read input information
	readInputInformation();
	//showArray(array);
	clock_t readTime = clock();

	// Set up start positions
	startPositionY = 0;
	startPositionX = 3;

	// Start program algorythm
	startProgram();
	//startProgram();

	// Find neigbours
	// Make moves
	
	clock_t workingTime = clock();
	
	// Write outpur/results informatiob
	writeOutputInformation();
	
	clock_t writtingTime = clock();
	clock_t allTime = clock();
	
	cout << "Start time: " << startTime << endl;
	cout << "Read time: " << (readTime-startTime)/double(CLOCKS_PER_SEC) << endl;
	cout << "Work time: " << (workingTime-readTime)/double(CLOCKS_PER_SEC) << endl;
	cout << "Write time: " << (writtingTime-workingTime)/double(CLOCKS_PER_SEC) << endl;
	cout << "All time: " << (allTime-startTime)/double(CLOCKS_PER_SEC) << endl;

	//showArray(array);
	*/
	
	return 0;
 }
